import { apiConfig } from '@/config/api.config';
import { Alert, useDataGrid } from '@/components';
import { useCallApi } from '@/hooks';
import { getAuth } from '@/auth';
import React, { useCallback, useEffect, useRef, useState } from 'react';
import { toast } from 'sonner';
import {
  Dialog,
  DialogBody,
  DialogContent,
  DialogDescription,
  DialogHeader,
  DialogTitle
} from '@/components/ui/dialog';
import { Input } from '@/components/ui/input';
import { Button } from '@/components/ui/button';
import { NumericFormat } from 'react-number-format';
import {
  Select,
  SelectContent,
  SelectItem,
  SelectTrigger,
  SelectValue
} from '@/components/ui/select';
import { useManageCurrencyContext } from '../hooks/useManageCurrencyContext';
import { doSaveLogActivity } from '@/actions/GlobalActions';
import { RefreshCw } from 'lucide-react';
import { initialStateCurrency, validateFormCurrency } from './Types';
interface CurrencyProps {
  ID: string;
  name: string;
}

const API_URL = apiConfig.service_wallet;

const EditDialog = () => {
  const parentRef = useRef<any | null>(null);
  const { showEditDialog, handleEditDialog, selectedCurrency } = useManageCurrencyContext();
  const { reload } = useDataGrid();
  const { PostData, GetData, PutData } = useCallApi();
  const parsedUser = getAuth()?.user;
  const [currencies, setCurrencies] = useState<CurrencyProps[]>([]);
  const [isSubmitting, setIsSubmitting] = useState(false);
  const [isLoading, setIsLoading] = useState(false);
  const [errors, setErrors] = useState<Record<string, string>>({});
  const [formField, setFormField] = useState(initialStateCurrency);
  const updated_time = new Date();
  const formattedTime = updated_time.toISOString().slice(0, 19).replace('T', ' ');

  const resetForm = () => {
    setFormField(initialStateCurrency);
    setErrors({});
  };

  const doUpdateCurrency = useCallback(
    async (e: React.FormEvent<HTMLFormElement>) => {
      e.preventDefault();
      setIsSubmitting(true);

      if (!validateFormCurrency(formField, setErrors)) {
        setIsSubmitting(false);
        return;
      }

      try {
        const response = await PutData(
          `${API_URL}/dashboard/currency/${selectedCurrency}`,
          formField
        );

        if (response?.status) {
          resetForm();
          handleEditDialog(false, null);
          toast.success('Success Update Currency');
          const createActivity = {
            module: 'Manage Currency',
            description: `Update Currency=> ${selectedCurrency}`,
            action: 'U'
          };

          doSaveLogActivity(createActivity);
          reload();
        } else {
          toast.error(response?.message);
        }
      } catch (error) {
        toast.error('Something went wrong');
      } finally {
        setIsSubmitting(false);
      }
    },
    [formField]
  );

  const doFetchData = useCallback(async (id: string) => {
    setIsLoading(true);
    const minDelay = new Promise((resolve) => setTimeout(resolve, 300));
    const fetchData = GetData(`${API_URL}/dashboard/currency/${id}`, { id });
    const [response] = await Promise.all([fetchData, minDelay]);

    if (response?.status) {
      setFormField((prev) => ({
        ...prev,
        status: response.data.status,
        code: response.data.code,
        name: response.data.name,
        prefix: response.data.prefix
      }));
    }
    setIsLoading(false);
  }, []);

  useEffect(() => {
    if (selectedCurrency) {
      doFetchData(selectedCurrency);
    }
  }, [selectedCurrency]);

  useEffect(() => {
    if (showEditDialog) {
      setFormField({
        ...formField,
        created_by: parsedUser.username,
        created_at: formattedTime
      });
    }
  }, [formattedTime]);

  useEffect(() => {
    if (showEditDialog === false) {
      resetForm();
    }
  }, [showEditDialog]);

  return (
    <Dialog open={showEditDialog} onOpenChange={(open) => handleEditDialog(open, null)}>
      <DialogContent className="container-fixed max-w-[768px] flex flex-col p-5 overflow-hidden">
        <DialogHeader>
          <DialogTitle>Currency - Update</DialogTitle>
          <DialogDescription></DialogDescription>
        </DialogHeader>
        <DialogBody ref={parentRef}>
          <div className="flex flex-col">
            {isLoading ? (
              <div className="flex flex-col items-center justify-center p-8">
                <div className="animate-pulse flex space-x-4 w-full">
                  <div className="flex-1 space-y-4 py-1">
                    <div className="h-4 bg-gray-200 rounded w-3/4"></div>
                    <div className="space-y-2">
                      <div className="h-4 bg-gray-200 rounded"></div>
                      <div className="h-4 bg-gray-200 rounded w-5/6"></div>
                    </div>
                  </div>
                </div>
                <p className="mt-4 text-gray-500">Loading Currency Details...</p>
              </div>
            ) : (
              <form onSubmit={doUpdateCurrency}>
                <div className="card-body grid gap-5">
                  <div className="grid grid-cols-8 gap-2 w-full items-center">
                    <label className="form-label flex items-center gap-1 col-span-2">
                      Code<span className="text-red-500">*</span>
                    </label>

                    <Input
                      className={`input col-span-6 ${errors.code ? 'border-red-500' : ''}`}
                      type="text"
                      autoComplete="off"
                      value={formField.code}
                      onChange={({ target }) => {
                        setFormField((prev) => ({ ...prev, code: target.value }));
                        setErrors((prev) => ({ ...prev, code: '' }));
                      }}
                    />
                    {errors.code && (
                      <span className="text-red-500 text-xs mt-1 col-span-8 ml-[calc(25%+0.5rem)]">
                        {errors.code}
                      </span>
                    )}
                  </div>

                  <div className="grid grid-cols-8 gap-2 w-full items-center">
                    <label className="form-label flex items-center gap-1 col-span-2">
                      Name<span className="text-red-500">*</span>
                    </label>

                    <Input
                      className={`input col-span-6 ${errors.name ? 'border-red-500' : ''}`}
                      type="text"
                      autoComplete="off"
                      value={formField.name}
                      onChange={({ target }) => {
                        setFormField((prev) => ({ ...prev, name: target.value }));
                        setErrors((prev) => ({ ...prev, name: '' }));
                      }}
                    />
                    {errors.name && (
                      <span className="text-red-500 text-xs mt-1 col-span-8 ml-[calc(25%+0.5rem)]">
                        {errors.name}
                      </span>
                    )}
                  </div>

                  <div className="grid grid-cols-8 gap-2 w-full items-center">
                    <label className="form-label flex items-center gap-1 col-span-2">
                      Prefix<span className="text-red-500">*</span>
                    </label>

                    <Input
                      className={`input col-span-6 ${errors.prefix ? 'border-red-500' : ''}`}
                      type="text"
                      autoComplete="off"
                      value={formField.prefix}
                      onChange={({ target }) => {
                        setFormField((prev) => ({ ...prev, prefix: target.value }));
                        setErrors((prev) => ({ ...prev, prefix: '' }));
                      }}
                    />
                    {errors.prefix && (
                      <span className="text-red-500 text-xs mt-1 col-span-8 ml-[calc(25%+0.5rem)]">
                        {errors.prefix}
                      </span>
                    )}
                  </div>

                  <div className="grid grid-cols-8 gap-2 w-full items-center">
                    <label className="form-label flex items-center gap-1 col-span-2">
                      Status<span className="text-red-500">*</span>
                    </label>

                    <div className="col-span-6">
                      <Select
                        value={formField.status}
                        onValueChange={(value) => {
                          setFormField((prev) => ({ ...prev, status: value }));
                          setErrors((prev) => ({ ...prev, status: '' }));
                        }}
                      >
                        <SelectTrigger className={`w-full ${errors.status && 'border-red-500'}`}>
                          <SelectValue placeholder="Select" />
                        </SelectTrigger>
                        <SelectContent>
                          <SelectItem value="Y">Active</SelectItem>
                          <SelectItem value="N">Inactive</SelectItem>
                        </SelectContent>
                      </Select>
                      {errors.status && (
                        <span className="text-red-500 text-xs mt-1">{errors.status}</span>
                      )}
                    </div>
                  </div>
                  <div className="flex justify-end gap-5">
                    <Button variant="default" type="submit" disabled={isSubmitting}>
                      {isSubmitting ? (
                        <RefreshCw className="animate-spin h-8 w-8 text-white mx-3" />
                      ) : (
                        'Create'
                      )}
                    </Button>
                  </div>
                </div>
              </form>
            )}
          </div>
        </DialogBody>
      </DialogContent>
    </Dialog>
  );
};

export default EditDialog;
